# DOW funkcja obliczaj/aca dzie/n tygodnia na podstawie podanej daty
#
# (TP, 1995)
#

function chi (x) { if (x > 0) { return 0 } else {return 1 } }

# FUNKCJA dow ----------------------------------------------------------
# argumenty:          y -- rok, m -- miesi/ac, d -- dzie/n (w miesi/acu),  
# np:                 1994,6,12
# zwracana warto/s/c: numer dnia w tygodniu
# ----------------------------------------------------------------------

function dow(y, m, d,           c, i, dy, dw){  
   _DOW[1]="Poniedzia/lek";  _DOW[2]="Wtorek";    _DOW[3]="/Sroda";
   _DOW[4]="Czwartek";      _DOW[5]="Pi/atek";    _DOW[6]="Sobota";
   _DOW[7]="Niedziela";

   c[1] = 31;  c[2]  = 28 + chi(y % 4) - chi(y % 100) + chi(y % 400);
   c[3] = 31;  c[4]  = 30;   c[5] = 31;  c[6] = 30; c[7] = 31; c[8] = 31;
   c[9] = 30;  c[10] = 31;  c[11] = 30; c[12] = 31;

   for (i = 1; i <= m - 1; i++ )
	   dy = dy + c[i];

   dy = dy + d;

   dw = (5+y+dy+int((y - 1)/4) - int((y-1)/100) + int((y - 1)/400)) % 7 +1;
   
   return dw;
}

# Test:
BEGIN {#
print "Grunwald, 14 VII 1410,", _DOW[dow(1410,7,14)];
print "Gettysburg, 1--3 VII 1863,", _DOW[dow(1863,7,1)] "--" _DOW[dow(1863,7,3)];
print "Drezno, 13--14 II 1945,", _DOW[dow(1945,2,13)] "--" _DOW[dow(1945,2,14)];
}
