# WFREQX.awk
#   usage: gawk -f wfreqx.awk file (raven.txt is delivered for testing)
#
# Print list of word frequencies
# idea borrowed from: GAWK manual p.~141
# coding and extension TP (24.3.96)
#
{ gsub(/[\.,;:"'`!?]/,""); gsub("---"," "); }
{ for (i=1; i <= NF; i++) { freq[$i]++ } }
END {for (word in freq) { printf "\%s\t%d\n", word, freq[word] }}
